"""
Contains setup functions for test data, these are returned in a QuickBunch dictionary, with some annotation about the number of data sets
"""

from . import simple_set_1
from . import random_sets

datasets = {
    'simple1'     :      simple_set_1.desc_simple1,
    'simple2'     :      simple_set_1.desc_simple2,
    'simple3'     :      simple_set_1.desc_simple3,
    'simple4'     :      simple_set_1.desc_simple4,
    'rand10_log1k' :     random_sets.desc_rand10_log1k,
    'rand10_lin1k' :     random_sets.desc_rand10_lin1k,
    'rand6_log100' :     random_sets.desc_rand6_log100,
    'rand6_lin100' :     random_sets.desc_rand6_log100,
    'rand2_log100' :     random_sets.desc_rand2_log100,
    'rand2_lin100' :     random_sets.desc_rand2_log100,
}


def iirrational_data(
    name,
    set_num = 0,
    instance_num = 0,
    **kwargs
):
    return datasets[name].generator(
        sN = set_num,
        iN = instance_num,
        **kwargs
    )

