# -*- coding: utf-8 -*-
"""
.. autofunction:: masked_argsort
"""
from __future__ import division, print_function, unicode_literals
from collections import Mapping

def argscan(*args, **kwargs):
    """
    First argument must be the attribute name, so that it can generate error messages
    any Mapping types are searched for the argument name!
    """
    arg = kwargs.get('arg', None)
    for val in args:
        if val is REQ:
            raise TypeError("Argument {0} is required and must be supplied to above function".format(arg))
        elif isinstance(val, Mapping):
            m_arg = val.get(arg, None)
            if m_arg is not None:
                return m_arg
        elif val is not None:
            return val
    #return the last value, likely None or the loop would have returned it
    return val


#Special unique value to specify that arguments are required
REQ = (argscan, 'REQUIRED')
